xmonad-contrib-0.13: Third party extensions for xmonad

Copyright | (c) Peter Jones 2015
License | BSD3-style (see LICENSE)
Maintainer | pjones@devalot.com
Stability | unstable
Portability | not portable
Safe Haskell | None
Language | Haskell98

XMonad.Layout.Hidden

Contents

- Usage

Description

Similar to XMonad.Layout.Minimize but completely removes windows from the window set so XMonad.Layout.BoringWindows isn't necessary. Perfect companion to XMonad.Layout.BinarySpacePartition since it can be used to move windows to another part of the BSP tree.

Synopsis

- data HiddenMsg
  - = HideWindow Window
  - | PopNewestHiddenWindow
  - | PopOldestHiddenWindow
- hiddenWindows :: LayoutClass l Window => l Window -> ModifiedLayout HiddenWindows l Window
- hideWindow :: Window -> X ()
- popOldestHiddenWindow :: X ()
- popNewestHiddenWindow :: X ()

# Usage

You can use this module with the following in your `~/.xmonad/xmonad.hs`:

    import XMonad.Layout.Hidden

Then edit your `layoutHook` by adding the `HiddenWindows` layout modifier:

    myLayout = hiddenWindows (Tall 1 (3/100) (1/2)) ||| Full ||| etc..
    main = xmonad def { layoutHook = myLayout }

For more detailed instructions on editing the layoutHook see:

XMonad.Doc.Extending

In the key bindings, do something like:

           , ((modMask, xK_backslash), withFocused hideWindow)
           , ((modMask .|. shiftMask, xK_backslash), popOldestHiddenWindow)
           ...

For detailed instruction on editing the key bindings see:

XMonad.Doc.Extending.

data HiddenMsg Source #

Messages for the `HiddenWindows` layout modifier.

Constructors

HideWindow Window | Hide a window.
PopNewestHiddenWindow | Restore window (FILO).
PopOldestHiddenWindow | Restore window (FIFO).

Instances

Eq HiddenMsg Source # |
Methods (==) :: HiddenMsg -> HiddenMsg -> Bool # (/=) :: HiddenMsg -> HiddenMsg -> Bool #
Message HiddenMsg Source # |

hiddenWindows :: LayoutClass l Window => l Window -> ModifiedLayout HiddenWindows l Window Source #

Apply the `HiddenWindows` layout modifier.

hideWindow :: Window -> X () Source #

Remove the given window from the current layout. It is placed in list of hidden windows so it can be restored later.

popOldestHiddenWindow :: X () Source #

Restore a previously hidden window. Using this function will treat the list of hidden windows as a FIFO queue. That is, the first window hidden will be restored.

popNewestHiddenWindow :: X () Source #

Restore a previously hidden window. Using this function will treat the list of hidden windows as a FILO queue. That is, the most recently hidden window will be restored.